function errplot(itype)
clf
fid = fopen('fort.61');
info = fscanf(fid,'%d %d',2);
status = fclose(fid);
%
nrow = info(1);
ncol = info(2);
%
fid = fopen('fort.66');
data = fscanf(fid,'%g',[2 nrow*ncol]);
data = data';
status = fclose(fid);
%
q1 = reshape(data(:,1),nrow,ncol);
q2 = reshape(data(:,2),nrow,ncol);
errs = q1-q2;
%
qmin = 1e6;
qmax = -1e6;
qmin = min(qmin,min(min(errs)));
qmax = max(qmax,max(max(errs)));
%
if itype == 1
% contours

   contour(errs,30);
elseif itype == 2
% pseudo-color

   pcolor(errs);
   yrbcolormap;
   shading('interp');
   caxis([qmin qmax]);
   colorbar;
elseif itype == 3
%  Schlieren plot, we compute gradient  (following Quirk)

   [Ax,Ay] = gradient(errs);
   errs = sqrt(Ax.*Ax + Ay.*Ay);
   phandle = pcolor(errs);
   shading('flat');
   colormap(flipud(gray(2048)).^20)
elseif itype == 4 
% surface

   surfl(errs);
elseif itype == 5
   contour3(errs,30);
elseif itype == 6
   meshc(errs);
end
%
format long;
qrange = [qmin,qmax]
%axis image
%axis('square')
