c
c ------------------------------------------------------------------
c
      program main
      dimension F(120,100),BDB(81),W(2243),X(101),Y(81) 
C                                                                       
C     # main program to illustrate the use of hwscrt
c
C     # NOTE THAT W is DIMENSIONED:
C     # 4*(N+1)+(13+INT(LOG2(N+1)))*(M+1)
C                                                                       
      IDIMF = 120                                                      
      A = 0.                                                          
      B = 2.                                                         
      M = 100                                                           
      MBDCND = 2                                                       
      C = -1.                                                         
      D = 3.                                                           
      N = 80                                                            
      NBDCND = 0                                                        
      ELMBDA = -4.                                                      
C                                                                     
C     AUXILIARY QUANTITIES.                                             
C                                                                      
      PI = 3.14159265358979                                             
      PIBY2 = PI/2.                                                   
      PISQ = PI**2                                                      
      MP1 = M+1                                                        
      NP1 = N+1                                                       
C                                                                    
C     GENERATE AND STORE GRID POINTS FOR THE PURPOSE OF COMPUTING   
C     BOUNDARY DATA AND THE RIGHT SIDE OF THE HELMHOLTZ EQUATION.      
C                                                                     
      do i=1,MP1                                                 
         X(i) = FLOAT(i-1)/50.                                      
         enddo
c                                                    
      do j=1,NP1                                                  
         Y(j) = -1.+FLOAT(j-1)/20.                                   
         enddo                                                      
c                                                                 
c     # GENERATE BOUNDARY DATA.                                       
      do J=1,NP1                                              
         BDB(J) = 4.*COS((Y(J)+1.)*PIBY2)                        
         enddo                                                  
c                                                            
c     # BDA, BDC, AND BDD ARE DUMMY VARIABLES.               
      do J=1,NP1                                    
         F(1,J) = 0.                                 
         enddo                                   
c                                              
c     # GENERATE RIGHT SIDE OF EQUATION.       
      do I=2,MP1                  
         do J=1,NP1            
            F(I,J) = (2.-(4.+PISQ/4.)*X(I)**2)*COS((Y(J)+1.)*PIBY2)  
            enddo                                                 
         enddo                                                 
c
      CALL hWSCRT(A,B,M,MBDCND,BDA,BDB,C,D,N,NBDCND,BDC,BDD, 
     &            ELMBDA,F,IDIMF,PERTRB,IERROR,W)          
C                                                        
C     COMPUTE DISCRETIZATION ERROR.  THE EXACT SOLUTION IS         
C                U(X,Y) = X**2*COS((Y+1)*PIBY2)                   
C                                                               
      ERR = 0.                                                
      DO 108 I=1,MP1                                      
         DO 107 J=1,NP1                               
            Z = ABS(F(I,J)-X(I)**2*COS((Y(J)+1.)*PIBY2))        
            IF (Z .GT. ERR) ERR = Z                           
  107    CONTINUE                                          
  108 CONTINUE                                           
      PRINT 1001 , IERROR,ERR                         
C                                                
c     # output solution
      write(61,*) mp1,np1
      do i=1,mp1
         do j=1,np1
            write(66,*) f(i,j),
     &                  X(I)**2*COS((Y(J)+1.)*PIBY2)
            enddo
         enddo
C                                                                    
C                                                                   
 1001 FORMAT (///9H IERROR =,I2,10X,22HDISCRETIZATION ERROR =,E12.5) 
C                                                                 
      END                                                      
