function matplot(m,itype)
clf
fid = fopen('fort.61');
info = fscanf(fid,'%d %d',2);
status = fclose(fid);
%
nrow = info(1);
ncol = info(2);
%
fid = fopen('fort.66');
data = fscanf(fid,'%g',[2 nrow*ncol]);
data = data';
status = fclose(fid);
%
q1 = reshape(data(:,m),nrow,ncol);
%
qmin = 1e6;
qmax = -1e6;
qmin = min(qmin,min(min(q1)));
qmax = max(qmax,max(max(q1)));
%
if itype == 1
% contours

   contour(q1,30);
elseif itype == 2
% pseudo-color

   pcolor(q1);
   yrbcolormap;
   shading('interp');
   caxis([qmin qmax]);
   colorbar;
elseif itype == 3
%  Schlieren plot, we compute gradient  (following Quirk)

   [Ax,Ay] = gradient(q1);
   q1 = sqrt(Ax.*Ax + Ay.*Ay);
   phandle = pcolor(q1);
   shading('flat');
   colormap(flipud(gray(2048)).^20)
elseif itype == 4 
% surface

   surfl(q1);
elseif itype == 5
   contour3(q1,30);
elseif itype == 6
   meshc(q1);
end
%
format long;
qrange = [qmin,qmax]
%axis image
%axis('square')
